package com.docus.server.service;

import com.docus.infrastructure.web.request.SearchDTO;
import com.docus.infrastructure.web.response.PageResult;
import com.docus.server.dto.recovery.rcvsysparam.AddRcvSysParamDTO;
import com.docus.server.dto.recovery.rcvsysparam.DeleteRcvSysParamDTO;
import com.docus.server.dto.recovery.rcvsysparam.EditRcvSysParamDTO;
import com.docus.server.vo.recovery.rcvsysparam.RcvSysParamVO;

import java.io.Serializable;
import java.util.Collection;
import java.util.List;

/**
 * 系统参数表 服务接口
 *
 * @author AutoGenerator
 * @since 2023-09-13
 */
public interface IRcvSysParamService {
    /**
     * 按主键查询
     *
     * @param id 主键id
     * @return 实体
     */
    RcvSysParamVO findById(Serializable id);

    /**
     * 按主键集合查询
     *
     * @param ids 主键ids
     * @return 实体列表
     */
    List<RcvSysParamVO> findByIds(List<Serializable> ids);

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    List<RcvSysParamVO> findBy(String propertyName, Object propertyValue);

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体列表
     */
    List<RcvSysParamVO> findBy(String propertyName, Collection<?> propertyValue);

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体
     */
    RcvSysParamVO findOneBy(String propertyName, Object propertyValue);

    /**
     * 按属性查询
     *
     * @param propertyName  属性名
     * @param propertyValue 属性值
     * @return 实体
     */
    RcvSysParamVO findOneBy(String propertyName, Collection<?> propertyValue);

    /**
     * 查询所有
     *
     * @return 实体列表
     */
    List<RcvSysParamVO> findAll();

    /**
     * 新增
     *
     * @param addRcvSysParamDTO 新增参数
     * @return 成功或失败
     */
    boolean add(AddRcvSysParamDTO addRcvSysParamDTO);

    /**
     * 批量新增
     *
     * @param addRcvSysParamDTO 新增参数
     * @return 成功或失败
     */
    boolean addBatch(List<AddRcvSysParamDTO> addRcvSysParamDTO);

    /**
     * 新增或编辑
     *
     * @param editRcvSysParamDTO 新增或编辑参数
     * @return 成功或失败
     */
    boolean addOrEdit(EditRcvSysParamDTO editRcvSysParamDTO);

    /**
     * 批量新增或编辑
     *
     * @param editRcvSysParamDTO 新增或编辑参数
     * @return 成功或失败
     */
    boolean addOrEditBatch(List<EditRcvSysParamDTO> editRcvSysParamDTO);

    /**
     * 编辑
     *
     * @param editRcvSysParamDTO 编辑参数
     * @return 成功或失败
     */
    boolean edit(EditRcvSysParamDTO editRcvSysParamDTO);

    /**
     * 批量编辑
     *
     * @param editRcvSysParamDTO 编辑参数
     * @return 成功或失败
     */
    boolean editBatchById(List<EditRcvSysParamDTO> editRcvSysParamDTO);

    /**
     * 批量删除
     *
     * @param deleteRcvSysParamDTO 删除参数
     * @return 成功或失败
     */
    int delete(DeleteRcvSysParamDTO deleteRcvSysParamDTO);

    /**
     * 按主键删除
     *
     * @param id 删除参数
     * @return 成功或失败
     */
    int delete(Serializable id);

    /**
     * 按属性删除
     *
     * @param propertyName  删除属性名
     * @param propertyValue 删除属性值
     * @return 成功或失败
     */
    int deleteBy(String propertyName, Object propertyValue);

    /**
     * 按属性删除
     *
     * @param propertyName  删除属性名
     * @param propertyValue 删除属性值集合
     * @return 成功或失败
     */
    int deleteBy(String propertyName, Collection<?> propertyValue);

    /**
     * 按主键集合批量删除
     *
     * @param ids 删除参数
     * @return 成功或失败
     */
    int deleteByIds(Collection<? extends Serializable> ids);

    /**
     * 关键字搜索
     *
     * @param searchDTO 搜索参数
     * @return 分页列表
     */
    PageResult<RcvSysParamVO> search(SearchDTO searchDTO);

    /**
     * 名称不重复
     *
     * @param id   主键
     * @param name 名称
     * @return 名称重复数量
     */
    int findByIdAndName(Serializable id, String name);
}
